include:
    - remote: "https://gitlab.com/studieverenigingvia/ict/templates/raw/master/helm.gitlab-ci.yml"

stages:
- lint
- build
- tag
- deploy

variables:
  BUILD_ID: build-${CI_PIPELINE_IID}
  BUILD_IMAGE_FRONTEND: ${CI_REGISTRY_IMAGE}/frontend:${BUILD_ID}
  BUILD_IMAGE_BACKEND: ${CI_REGISTRY_IMAGE}/backend:${BUILD_ID}
  CHART: centurion
  NAMESPACE: via

lint_helm:
    stage: lint
    extends: .helm-lint

lint:
  stage: lint
  image: node:16
  before_script: [ ]
  script:
    - npm ci --no-progress --no-optional
    - npm run -w backend lint
    - npm run -w frontend lint
    - npm run check-fmt

build-frontend:
  stage: build
  needs: [ ]
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [ "" ]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
        /kaniko/executor
        --context "${CI_PROJECT_DIR}/frontend"
        --dockerfile "${CI_PROJECT_DIR}/frontend/Dockerfile"
        --cache=true
        --cache-copy-layers
        --destination "${BUILD_IMAGE_FRONTEND}"

build-backend:
  stage: build
  needs: [ ]
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [ "" ]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
    - >-
        /kaniko/executor
        --context "${CI_PROJECT_DIR}/backend"
        --dockerfile "${CI_PROJECT_DIR}/backend/Dockerfile"
        --cache=true
        --cache-copy-layers
        --destination "${BUILD_IMAGE_BACKEND}"

tag:
  stage: tag
  image:
    name: gcr.io/go-containerregistry/crane:debug
    entrypoint: [ "" ]
  script:
    - crane auth login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - crane tag ${BUILD_IMAGE_FRONTEND} $CI_COMMIT_REF_SLUG
    - crane tag ${BUILD_IMAGE_BACKEND} $CI_COMMIT_REF_SLUG

deploy:
  stage: deploy
  extends: .helm-upgrade
  variables:
    IMAGE_TAG: $CI_COMMIT_REF_SLUG
  environment:
      name: production
      url: https://centurion.svia.nl
  only:
      refs:
          - master
  when: manual
  allow_failure: false
